#pragma once
#include "uart/ProtocolSender.h"
/*
*此文件由GUI工具生成
*文件功能：用于处理用户的逻辑相应代码
*功能说明：
*========================onButtonClick_XXXX
当页面中的按键按下后系统会调用对应的函数，XXX代表GUI工具里面的[ID值]名称，
如Button1,当返回值为false的时候系统将不再处理这个按键，返回true的时候系统将会继续处理此按键。比如SYS_BACK.
*========================onSlideWindowItemClick_XXXX(int index) 
当页面中存在滑动窗口并且用户点击了滑动窗口的图标后系统会调用此函数,XXX代表GUI工具里面的[ID值]名称，
如slideWindow1;index 代表按下图标的偏移值
*========================onSeekBarChange_XXXX(int progress) 
当页面中存在滑动条并且用户改变了进度后系统会调用此函数,XXX代表GUI工具里面的[ID值]名称，
如SeekBar1;progress 代表当前的进度值
*========================ogetListItemCount_XXXX() 
当页面中存在滑动列表的时候，更新的时候系统会调用此接口获取列表的总数目,XXX代表GUI工具里面的[ID值]名称，
如List1;返回值为当前列表的总条数
*========================oobtainListItemData_XXXX(ZKListView::ZKListItem *pListItem, int index)
 当页面中存在滑动列表的时候，更新的时候系统会调用此接口获取列表当前条目下的内容信息,XXX代表GUI工具里面的[ID值]名称，
如List1;pListItem 是贴图中的单条目对象，index是列表总目的偏移量。具体见函数说明
*========================常用接口===============
*LOGD(...)  打印调试信息的接口
*mTextXXXPtr->setText("****") 在控件TextXXX上显示文字****
*mButton1Ptr->setSelected(true); 将控件mButton1设置为选中模式，图片会切换成选中图片，按钮文字会切换为选中后的颜色
*mSeekBarPtr->setProgress(12) 在控件mSeekBar上将进度调整到12
*mListView1Ptr->refreshListView() 让mListView1 重新刷新，当列表数据变化后调用
*mDashbroadView1Ptr->setTargetAngle(120) 在控件mDashbroadView1上指针显示角度调整到120度
*
* 在Eclipse编辑器中  使用 “alt + /”  快捷键可以打开智能提示
*/
#include "can/socket_can.h"
#include <vector>
#include <string>
#include "utils/GpioHelper.h"
#include "m_can/libsocketcan.h"
using namespace std;
using namespace socket_can;

#define DEBUG printf("--%d-- --%s-- DEBUG!!!\n", __LINE__, __FILE__);
#define DEBUG_TEST		1			//启用调试按键



static can_frame  cmsg = {0x7ff, 8, 0, 0, 0, {0xaa, 0x55, 0x00, 0xff, 0xff, 0x00, 0x55, 0xaa}};
static can_frame  recover_test = {0x001, 1, 0, 0, 0, {0xaa, 0x55, 0x00, 0xff, 0xff, 0x00, 0x55, 0xaa}};


static int state;

SocketCAN* pCan = NULL;
vector<string> CanrecBuf;
void onCanReadCallback(can_frame& can){
	char buff[64];
	sprintf(buff,"Can:[%08x]  %02x %02x %02x %02x %02x %02x %02x %02x",can.can_id,can.data[0]
				,can.data[1],can.data[2],can.data[3],can.data[4],can.data[5],can.data[6],can.data[7]);
	CanrecBuf.push_back(buff);
	printf("read :%s \n",buff);
	if(CanrecBuf.size() > 500){
		CanrecBuf.clear();
	}

	int index;
	index = CanrecBuf.size()-20;
	if(index < 0){
		index = 0;
	}
	mListView1Ptr->setSelection(index);
	mListView1Ptr->refreshListView();
}
/**
 * 注册定时器
 * 填充数组用于注册定时器
 * 注意：id不能重复
 */
static S_ACTIVITY_TIMEER REGISTER_ACTIVITY_TIMER_TAB[] = {
	{5,  50}, //定时器id=0, 时间间隔50ms
	{0,  5000},
	{1,  8*1000},
	{2,  3000},
};

/**
 * 当界面构造时触发
 */
static void onUI_init(){
    //Tips :添加 UI初始化的显示代码到这里,如:mText1Ptr->setText("123");
	pCan = NULL;
}

/**
 * 当切换到该界面时触发
 */
static void onUI_intent(const Intent *intentPtr) {
    if (intentPtr != NULL) {
        //TODO
    }
}



/*
 * 当界面显示时触发
 */
static void onUI_show() {
	//can_get_state("00", )
}

/*
 * 当界面隐藏时触发
 */
static void onUI_hide() {
}

/*
 * 当界面完全退出时触发
 */
static void onUI_quit() {

}

/**
 * 串口数据回调接口
 */
static void onProtocolDataUpdate(const SProtocolData &data) {

}

/**
 * 定时器触发函数
 * 不建议在此函数中写耗时操作，否则将影响UI刷新
 * 参数： id
 *         当前所触发定时器的id，与注册时的id相同
 * 返回值: true
 *             继续运行当前定时器
 *         false
 *             停止运行当前定时器
 */
static bool onUI_Timer(int id){
	switch (id) {
	case 5: {

//		enum can_state {
//			CAN_STATE_ERROR_ACTIVE = 0,	/* RX/TX error count < 96 */
//			CAN_STATE_ERROR_WARNING,	/* RX/TX error count < 128 */
//			CAN_STATE_ERROR_PASSIVE,	/* RX/TX error count < 256 */
//			CAN_STATE_BUS_OFF,		/* RX/TX error count >= 256 */
//			CAN_STATE_STOPPED,		/* Device is stopped */
//			CAN_STATE_SLEEPING,		/* Device is sleeping */
//			CAN_STATE_MAX
//		};

		//测试情况          停止是 4,开启后为0, 不论是否短接发送会变3,


		//测试情况          停止是 4,开启后为0, 不断接发送 2,  短接后发送数据才会变3,

		can_get_state("can0", &state);
		printf("--%d-- --%s-- state:%d \n", __LINE__, __FILE__, state);


#if !DEBUG_TEST
	   if(pCan && (state == CAN_STATE_ERROR_PASSIVE || state == CAN_STATE_ERROR_ACTIVE)) {	//状态2
		   pCan->write(cmsg.can_id, cmsg.can_dlc, cmsg.data);
		   can_get_state("can0", &state);			//检测状态 3
	   }

	   if(state == CAN_STATE_BUS_OFF) {					//状态3
		   can_do_restart("can0");
		   pCan->write(recover_test.can_id, recover_test.can_dlc, recover_test.data);
		   //can_get_state("can0", &state);			//检测状态 0
	   }
#endif

	}
	break;

	   case 0:
		mButton5Ptr->setSelected(!mButton5Ptr->isSelected());
		GpioHelper::output("GPIO_197", !mButton5Ptr->isSelected());
		    return false;

	   case 1: {
	       printf(" ButtonClick ButtonOpen !!!\n");
	       if(pCan == NULL){
	       	mButtonOpenPtr->setSelected(true);
	       	int bitRate = atoi(mEditTextBitRatePtr->getText().c_str());
	       	printf("get bitRate set:%d \n",bitRate);
	       	pCan = new SocketCAN("can0", bitRate, 5000);
	       	pCan->setCanReadCb(onCanReadCallback);
	       	pCan->startup();
	       	CanrecBuf.clear();
	       }else{
	    	   mButtonOpenPtr->setSelected(false);
	       	printf("pCan Open ,please Close first \n");
	       }
	   }
		       return false;

	   case 2:
		    can_get_state("can0", &state);
		    //printf("         --%d-- --%s-- state:%d ", __LINE__, __FILE__, state);
			   if(pCan && state != CAN_STATE_BUS_OFF) {
				   pCan->write(cmsg.can_id, cmsg.can_dlc, cmsg.data);
			   }
			   break;

		default:
			break;
	}
    return true;
}

/**
 * 有新的触摸事件时触发
 * 参数：ev
 *         新的触摸事件
 * 返回值：true
 *            表示该触摸事件在此被拦截，系统不再将此触摸事件传递到控件上
 *         false
 *            触摸事件将继续传递到控件上
 */
static bool onmainActivityTouchEvent(const MotionEvent &ev) {
    switch (ev.mActionStatus) {
		case MotionEvent::E_ACTION_DOWN://触摸按下
			//LOGD("时刻 = %ld 坐标  x = %d, y = %d", ev.mEventTime, ev.mX, ev.mY);
			break;
		case MotionEvent::E_ACTION_MOVE://触摸滑动
			break;
		case MotionEvent::E_ACTION_UP:  //触摸抬起
			break;
		default:
			break;
	}
	return false;
}
static bool onButtonClick_ButtonClose(ZKButton *pButton) {
    printf(" ButtonClick ButtonClose !!!\n");
    if(pCan){
    	delete pCan;
    	pCan = NULL;
    }
    else{
    	printf("Can Not Open \n");
    }
    return false;
}

static int getListItemCount_ListView1(const ZKListView *pListView) {
    //printf("getListItemCount_ListView1 !\n");
    return CanrecBuf.size();
}

static void obtainListItemData_ListView1(ZKListView *pListView,ZKListView::ZKListItem *pListItem, int index) {
    //printf(" obtainListItemData_ ListView1  !!!\n");
	pListItem->setText(CanrecBuf[index].c_str());
}

static void onListItemClick_ListView1(ZKListView *pListView, int index, int id) {
    //printf(" onListItemClick_ ListView1  !!!\n");
}

static bool onButtonClick_ButtonOpen(ZKButton *pButton) {
    printf(" ButtonClick ButtonOpen !!!\n");
    if(pCan == NULL){
    	pButton->setSelected(true);
    	int bitRate = atoi(mEditTextBitRatePtr->getText().c_str());
    	printf("get bitRate set:%d \n",bitRate);
    	pCan = new SocketCAN("can0", bitRate, 5000);
    	pCan->setCanReadCb(onCanReadCallback);
    	pCan->startup();
    	CanrecBuf.clear();
    }else{
    	pButton->setSelected(false);
    	printf("pCan Open ,please Close first \n");
    }

    return false;
}

static void onEditTextChanged_EditTextBitRate(const std::string &text) {
    printf(" onEditTextChanged_ EditTextBitRate %s !!!\n", text.c_str());
}

static void onEditTextChanged_EditTextAddr(const std::string &text) {
    printf(" onEditTextChanged_ EditTextAddr %s !!!\n", text.c_str());
}

static void onEditTextChanged_EditTextHexData(const std::string &text) {
    printf(" onEditTextChanged_ EditTextHexData %s !!!\n", text.c_str());

}

static int oneHexCharToHex(char h)
{
	int x = 0;
	if (isdigit(h)) {
		x = h - '0';
	} else if (isupper(h)) {
		x = h - 'A' + 10;
	} else {
		x = h - 'a' + 10;
	}
	return x;
}

/*Chaneg TEXT HEX such as E5BC35 to
* E5BC35 -->0xe5,0xbc,0x35
* inStr must >0 otherwise return -1*/
int ChangeTHEX2CPTR(const char * inHexString, uint8_t * outHex)
{
	int success = -1;
	int len = 0;
	int i;
	char ch1, ch2;
	do
	{
		if (NULL == inHexString || NULL == outHex) {
			printf("error: inHexString or outHex is null!\n");
			break;
		}
		len = strlen(inHexString);
		if (len <= 1) {
			printf("error: strlen(inHexString) <= 1!\n");
			break;
		}
		len &= ~1;
		for (i=0; i<len; i+=2) {
			ch1 = inHexString[i];
			ch2 = inHexString[i+1];
			outHex[i/2 + 1] = 0;
			if (isxdigit(ch1) && isxdigit(ch2)) {
				ch1 = oneHexCharToHex(ch1);
				ch2 = oneHexCharToHex(ch2);
				outHex[i/2] = (ch1 << 4) | ch2;
			} else {
				printf("error: %c or %c is not hex digit!\n", ch1, ch2);
				goto exit;
			}
		}
		success = 0;//OK
	} while (0);
exit:
	return success;
}
static bool onButtonClick_ButtonSend(ZKButton *pButton) {
    printf(" ButtonClick ButtonSend !!!\n");
    if(mEditTextAddrPtr->getText().size() != 8 ||
       		mEditTextHexDataPtr->getText().size()!= 16){
       	printf("Filter too short \n");
       	return false;
   }
   uint8_t id[4]={0};
   uint8_t data[8] ={0};
   ChangeTHEX2CPTR(mEditTextAddrPtr->getText().c_str(),id);
   ChangeTHEX2CPTR(mEditTextHexDataPtr->getText().c_str(),data);
   uint32_t id32 = id[0]<<24|id[1]<<16|id[2]<<8|id[3];
   printf("send data :%08x  \n",id32);
   if(pCan){
	   pCan->write(id32, 8, data);
   }


    return false;
}
static void onEditTextChanged_EditTextIDFIlter(const std::string &text) {
    //printf(" onEditTextChanged_ EditTextIDFIlter %s !!!\n", text.c_str());

}

static void onEditTextChanged_EditTextIDMask(const std::string &text) {
    //printf(" onEditTextChanged_ EditTextIDMask %s !!!\n", text.c_str());
}

static bool onButtonClick_ButtonSetFilter(ZKButton *pButton) {
    printf(" ButtonClick ButtonSetFilter !!!\n");
    if(mEditTextIDFIlterPtr->getText().size() != 8 ||
    		mEditTextIDMaskPtr->getText().size()!= 8){
    	printf("Filter too short \n");
    	return false;
    }
    uint8_t id[4]={0};
    uint8_t mask[4] ={0};
    ChangeTHEX2CPTR(mEditTextIDFIlterPtr->getText().c_str(),id);
    ChangeTHEX2CPTR(mEditTextIDMaskPtr->getText().c_str(),mask);
    uint32_t id32 = id[0]<<24|id[1]<<16|id[2]<<8|id[3];
    uint32_t mask32 = mask[0]<<24|mask[1]<<16|mask[2]<<8|mask[3];

    printf("get id:%08x ,mask :%08x \n",id32,mask32);
    if(pCan){
    	can_filter canfileter;
    	canfileter.can_id= id32;
    	canfileter.can_mask = mask32;
    	pCan->setFilter(&canfileter, 1);
    }

    return false;
}
static bool onButtonClick_Button575(ZKButton *pButton) {
    printf(" ButtonClick Button575 !!!\n");
	can_filter rfilter[1];
	rfilter[0].can_id = 0x575;
	rfilter[0].can_mask = (CAN_EFF_FLAG | CAN_RTR_FLAG | CAN_SFF_MASK);
	//setsockopt(pCan, SOL_CAN_RAW, CAN_RAW_FILTER, &canfileter, sizeof(canfileter));
    return false;
}

static bool onButtonClick_Button2(ZKButton *pButton) {
    printf(" ButtonClick Button2 !!!\n");

	can_filter rfilter[2];
	rfilter[0].can_id = 0x575;
	rfilter[0].can_mask = (CAN_EFF_FLAG | CAN_RTR_FLAG | CAN_SFF_MASK);
	rfilter[1].can_id = 0x531;
	rfilter[1].can_mask = (CAN_EFF_FLAG | CAN_RTR_FLAG | CAN_SFF_MASK);
	//setsockopt(pCan, SOL_CAN_RAW, CAN_RAW_FILTER, &rfilter, sizeof(rfilter));
    return false;
}
static bool onButtonClick_Button1(ZKButton *pButton) {
    printf(" ButtonClick Button1 !!!\n");
    EASYUICONTEXT->openActivity("NetSettingActivity");
    return false;
}


static bool onButtonClick_Button3(ZKButton *pButton) {
    printf(" ButtonClick Button3 !!!\n");
#if DEBUG_TEST
    can_get_state("can0", &state);
    //printf("         --%d-- --%s-- state:%d ", __LINE__, __FILE__, state);
	   if(pCan && state != CAN_STATE_BUS_OFF) {
		   pCan->write(cmsg.can_id, cmsg.can_dlc, cmsg.data);
	   }
#endif
    return false;
}

static bool onButtonClick_Button4(ZKButton *pButton) {
    printf(" ButtonClick Button4 !!!\n");
#if DEBUG_TEST
    can_do_restart("can0");
#endif
    return false;
}

static bool onButtonClick_Button5(ZKButton *pButton) {
    LOGD(" ButtonClick Button5 !!!\n");
    pButton->setSelected(!pButton->isSelected());
    GpioHelper::output("GPIO_197", !pButton->isSelected());
    return false;
}
